# Arcanea Ruby 2D Engine (ARE)
#
# Author:: Josef Smolka (mailto:maurel@gmail.com)
# Copyright:: Copyright (c) 2007 Josef Smolka
# Licence:: MIT Licence (http://www.opensource.org/licenses/mit-license.php)

class AREVector
  attr_accessor :x
  attr_accessor :y

  public

  def initialize(x = 0, y = 0)
    if(x.class == self.class)
      @x = x.x
      @y = x.y
    else
      @x = x
      @y = y
    end
  end

  def +(v)
    return AREVector.new(@x + v.x, @y + v.y)
  end

  def -(v)
    return AREVector.new(@x - v.x, @y - v.y)
  end

  def *(v)
    if(v.class != self.class)
      return AREVector.new(@x * v, @y * v)
    else
      return AREVector.new(@x * v.x, @y * v.y)
    end
  end

  def /(v)
    if(v.class != self.class)
      return AREVector.new(@x / v, @y / v)
    else
      return AREVector.new(@x / v.x, @y / v.y)
    end
  end

  def >(v)
    return (@x > v.x and @y > v.y)
  end

  def <(v)
    return (@x < v.x and @y < v.y)
  end

  def >=(v)
    return (@x >= v.x and @y >= v.y)
  end

  def <=(v)
    return (@x <= v.x and @y <= v.y)
  end

  def dot(v)
    return @x * v.x + @y * v.y
  end

  def sumsq
    return (@x * @x) + (@y * @y)
  end
end